/************************************************************************************
 * WrightEagle (Soccer Simulation League 2D)                                        *
 * BASE SOURCE CODE RELEASE 2009                                                    *
 * Copyright (C) 1998-2009 WrightEagle 2D Soccer Simulation Team,                   *
 *                         Multi-Agent Systems Lab.,                                *
 *                         School of Computer Science and Technology,               *
 *                         University of Science and Technology of China, China.    *
 *                                                                                  *
 * This program is free software; you can redistribute it and/or                    *
 * modify it under the terms of the GNU General Public License                      *
 * as published by the Free Software Foundation; either version 2                   *
 * of the License, or (at your option) any later version.                           *
 *                                                                                  *
 * This program is distributed in the hope that it will be useful,                  *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of                   *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                    *
 * GNU General Public License for more details.                                     *
 *                                                                                  *
 * You should have received a copy of the GNU General Public License                *
 * along with this program; if not, write to the Free Software                      *
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.  *
 ************************************************************************************/

#include "WorldModel.h"
#include "Observer.h"
#include "WorldState.h"
#include "InfoState.h"

WorldModel::WorldModel() {
	mpHistoryState[0] = new HistoryState;
	mpWorldState[0] = new WorldState(mpHistoryState[0]);	//ѵ״̬
															//world state of teammate's

	mpHistoryState[1] = new HistoryState;
	mpWorldState[1] = new WorldState(mpHistoryState[1]);	//ʱõģֵ״̬
															//world state of opponent's for calculate like opponent
}

WorldModel::~WorldModel() {
	delete mpWorldState[0];
	delete mpHistoryState[0];

	delete mpWorldState[1];
	delete mpHistoryState[1];
}

/**
 * Update WorldModel
 * @param observer current observer
 */
void WorldModel::Update(Observer *observer)
{
	//洢һµǰ
	//save current world state
	mpHistoryState[0]->UpdateHistory(*mpWorldState[0]);
	mpHistoryState[1]->UpdateHistory(*mpWorldState[1]);

	mpWorldState[0]->UpdateFromObserver(observer);		//Լʹõ״̬
														//our own worldstate for plan
	mpWorldState[1]->GetReverseFrom(mpWorldState[0]);	//ɹʱʹõ״̬
														//world state for calculating opponent's plan
}

const WorldState & WorldModel::GetWorldState(bool reverse) const
{
	return *(reverse? mpWorldState[1]: mpWorldState[0]);
}

WorldState & WorldModel::World(bool reverse)
{
	return *(reverse? mpWorldState[1]: mpWorldState[0]);
}

